//+------------------------------------------------------------------+
//|                     Triple-MA-Crossover - Massi .mq4             |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Dr. Massimiliano Papera"
#property link      "http://www.inattention-analytics.co.uk"

extern int magicNumber = 1111;
extern double lots = 0.5;
extern int MAFastPeriod = 8;
extern int MAMediumPeriod = 100;
extern int MASlowPeriod = 400;
extern bool UseTimeServer = true; // Use start & end times in Hours and Minutes HH:MM
extern string TradeStartTime = "1:05";
extern string TradeStopTime = "22:50";
//extern bool trail = True;
//extern double TrailingStop = 1000;
//extern int takeProfit = 0;
extern int stopLoss = 1500;

//extern int StartTime = 1:05; // Start hour of Trading day 
//extern int EndTime = 22:50; // End hour of Trading day


datetime CurrentTime;




int slippage = 3;
double takeProfit = 0;
//double stopLoss = 0;
int ticket;
int counter;
bool openOrder;
bool buySignal;
bool sellSignal;






//place before init, or after the code at the bottom
//{
//for (int i = 0; i < OrdersTotal(); i++) {
//OrderSelect(i, SELECT_BY_POS, MODE_TRADES);

//if ( OrderSymbol()==Symbol() ) 
//{
//if (OrderType() == OP_BUY) {
//if (Bid - OrderOpenPrice() > TrailingStop * MarketInfo(OrderSymbol(), MODE_POINT)) {
//if (OrderStopLoss() < Bid - TrailingStop * MarketInfo(OrderSymbol(), MODE_POINT)) {
//OrderModify(OrderTicket(), OrderOpenPrice(), Bid - TrailingStop * MarketInfo(OrderSymbol(), MODE_POINT), OrderTakeProfit(), Red);
//}
//}
//} else if (OrderType() == OP_SELL) {
//if (OrderOpenPrice() - Ask > TrailingStop * MarketInfo(OrderSymbol(), MODE_POINT)) {
//if ((OrderStopLoss() > Ask + TrailingStop * MarketInfo(OrderSymbol(), MODE_POINT)) || 
//(OrderStopLoss() == 0)) {
//OrderModify(OrderTicket(), OrderOpenPrice(),
//Ask + TrailingStop * MarketInfo(OrderSymbol(), MODE_POINT), OrderTakeProfit(), Red); 
//}
//}
//}
//}
//}
//}



//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
   return(0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{


   openOrder = false;
   generateSignals();
   
   //monitor open trades
   for(counter=0;counter<OrdersTotal();counter++)   
   {
      OrderSelect(counter, SELECT_BY_POS, MODE_TRADES);     
      if (OrderMagicNumber() == magicNumber)
      {
         openOrder = true;
         if (OrderType() == OP_BUY && !buySignal)
         {
            closeBuyTrade();
            openOrder = false;
         }
         else if (OrderType() == OP_SELL && !sellSignal)
         {
            closeSellTrade();
            openOrder = false;
         }
      }
   }
   
   //if there are no open orders, check for a signal
   if (!openOrder)
   {
      if (buySignal)
         placeBuy();
      else if (sellSignal)
         placeSell();
   }   
   return(0);
}



//+------------------------------------------------------------------+
//| place BUY trade                                                  |
//+------------------------------------------------------------------+
void placeBuy()
{
   RefreshRates();            
   ticket=OrderSend(Symbol(),OP_BUY,lots,Ask,slippage,Ask-(stopLoss*Point),takeProfit,"buy",magicNumber,0,Green);  
   if(ticket<0)
   {
      Print("BUY failed with error #",GetLastError()," at ",Ask);
      return;
   }
}
//+------------------------------------------------------------------+
//| place SELL trade                                                 |
//+------------------------------------------------------------------+
void placeSell()
{
   RefreshRates();            
   ticket=OrderSend(Symbol(),OP_SELL,lots,Bid,slippage,Bid+(stopLoss*Point),takeProfit,"sell",magicNumber,0,Red);  
   if(ticket<0)
   {
      Print("SELL failed with error #",GetLastError()," at ",Bid);
      return;
   }
}
//+------------------------------------------------------------------+
//| generate a buy or sell signal
//+------------------------------------------------------------------+






void generateSignals()
{
// Trading hours

if(UseTimeServer == true)
{
CurrentTime = TimeCurrent();

int GetWeekday = TimeDayOfWeek(CurrentTime);
//int GetHour = TimeHour(CurrentTime);
//int GetMinute = TimeMinute(CurrentTime);


if(CurrentTime>StrToTime(TradeStartTime) && CurrentTime<StrToTime(TradeStopTime) && GetWeekday <6)

// if(GetHour > StartTime && GetHour < EndTime && GetWeekday <6)
{
bool TradeAllowed = true;

}
else TradeAllowed = false;
}
else TradeAllowed = true;


   buySignal = false;
   sellSignal = false;
   
   if (iMA(NULL,0,MAFastPeriod,0,MODE_EMA,PRICE_CLOSE,1) > iMA(NULL,0,MAMediumPeriod,0,MODE_EMA,PRICE_CLOSE,1) &&
       iMA(NULL,0,MAFastPeriod,0,MODE_EMA,PRICE_CLOSE,1) > iMA(NULL,0,MASlowPeriod,0,MODE_EMA,PRICE_CLOSE,1) && TradeAllowed == true)
      buySignal = true;

   if (iMA(NULL,0,MAFastPeriod,0,MODE_EMA,PRICE_CLOSE,1) < iMA(NULL,0,MAMediumPeriod,0,MODE_EMA,PRICE_CLOSE,1) &&
       iMA(NULL,0,MAFastPeriod,0,MODE_EMA,PRICE_CLOSE,1) < iMA(NULL,0,MASlowPeriod,0,MODE_EMA,PRICE_CLOSE,1)&& TradeAllowed == true)
      sellSignal = true;

   //if (trail) trail();
}
//+------------------------------------------------------------------+
//| close BUY trade
//+------------------------------------------------------------------+
void closeBuyTrade()
{
      RefreshRates();
      OrderClose(OrderTicket(),OrderLots(),Bid,slippage,Green);     
}
//+------------------------------------------------------------------+
//| close SELL trade
//+------------------------------------------------------------------+
void closeSellTrade()
{
      RefreshRates();
      OrderClose(OrderTicket(),OrderLots(),Ask,slippage,Red);  
}


